/* *****************************************************************
 * High Speed Serial Driver for the Dynamic Engineering PMC BiSerial
 * This driver only ddoes transmit... ie implement write  system call
 * This driver is Copyright David Armstrong 2000, 2001
 * This source code is released under GPL see the file gpl.txt for 
 * details
 *******************************************************************
 */ 


const int CardId = 5;
const int VendorId = 0x10ee;

struct PMC
{
        volatile long Base;    /* base control register */
        volatile long Tx;      /* Tx control register   */
        volatile long Txs;     /* Special Tx register   */
        volatile long Rx;      /* Rx control Register   */
        volatile long Rxs;     /* Special Rx register   */
        volatile long Stat0;   /* Status register 0     */
        volatile long Stat1;   /* Status Register 1     */
        volatile long Intc;    /* Interrupt Control     */
        volatile long FifoTx;  /* Tx FIFO               */
        volatile long FifoRx;  /* Rx FIFO               */
        volatile long DirTerm; /* Direction and Termination Control */
/*      long Switch; */ /* User switch read only */  /* This switch is at offset 44, a long ways from dir term */
};



#define BUFFER_SIZE_ORDER  19    /* 2^ 16 = 65536   */

typedef long Native;
const int BUFFER_SIZE  = (1<< (BUFFER_SIZE_ORDER-2));
