


#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <syscall.h>
#include <sys/timeb.h>
#include <math.h>
#include <sys/ioctl.h>
#include <stream.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>


void usage(void)
{
  cout <<endl << endl << "Stats"<< endl;
  cout <<" Reads info from the proc filesystem and calculates"<<endl;
  cout <<" mean and standard deviation."<<endl;
  cout <<"\n -? Displays these usage notes.";
}




int main ( int argc , char ** argv )
{

  char s1[500];
  char s2[500];
  int min;
  int max; 
  int NuInterrupts;
  long SumTime;
  long SumTimeSqr;
  float mean;
  double StartTime,EndTime;
  double ElapsedTime;
  long NuBytes;
  float SD;
  float var;
  
  int   h;
  cout <<"Calculating stats:"<<endl;

  if (argc > 1)
  {
       usage();
       exit(1);
  }

  char Name[1024];
  sprintf ( Name , "/proc/hss/stats");
  h = open ( Name ,O_RDONLY );
  if ( h < 2 )
  {
      cout << Name <<" FAILED open"<< endl;
      return 1;
  }
  
  int len = read(h,s1,500);
  s1[len] = 0;
  cout << "Length of string" << len << endl;
  sscanf(s1,"%s %s %s %s %s %s %s %s %i %i %i %ld %ld %lf %lf %ld",s2,s2,s2,s2,s2,s2,s2,s2,&min,&max,&NuInterrupts,&SumTime,&SumTimeSqr,&StartTime,&EndTime,&NuBytes);
  cout << " Min " << min << endl;
  cout << " Max " << max << endl;
  cout << " Number of interrupts " << NuInterrupts << endl;
  if (NuInterrupts != 0)
  {
      mean =  (float) SumTime/ (float) NuInterrupts;
      cout << " Mean " << mean << endl;
      var = (float) SumTimeSqr/(float) NuInterrupts- mean*mean;
      cout << " Variance "<< var << endl;
      SD = sqrt(var);
      cout << " Standard deviation " << SD <<endl;
  
  }
  cout << "Start :" << StartTime << endl;
  cout << "End :" << EndTime << endl;
  ElapsedTime = EndTime - StartTime ;
  if ( ElapsedTime != 0)
  {
    cout << " Elapsed time " << ElapsedTime << endl;
    cout << " Number of bits " << 8*NuBytes << endl;
    cout << " Bits per second " << (8*NuBytes)/(ElapsedTime)<< endl;
  }
  close(h);
  return 0;
 
}
